/* yasep/tool/YASMed.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org

created 2009-01-23 by yg@yasep.org as tools/listed.js
2009-01-26
2009-01-31
2009-02-01
2009-02-06 : moved most code to the listed object
2009-02-10 : style changes, feedback from St<E9>phane Moriaux etc.
Feb 12 01:07:16 2009 : style changes again
Feb 16 02:34:50 2009
todo : gestion des <E9>v<E9>nements avec seamonkey : souris qui d<E9>tecte pas le rel<E2>chement du bouton
Feb 24 01:30:28 2009 : j'ai 32 ans ! et j'ai r<E9>uni les 2 images de la poubelle en une [:kikiv]
2009-07-07 : moved to tools/
2009-07-11 : new argument to ygwm.new_window
2009-07-22 : column hiding
2009-07-27 : duplicate_listing_row fixed
lun. févr. 13 04:59:42 CET 2012 : YASMed.js
lun. févr. 20 07:07:42 CET 2012 : export VHDL
sam. mars 24 14:01:02 CET 2012 : substitute



Purpose : Create and maintain windows of the
 iterative assembly editor (derived from listed)

TODO : cleanup the trigger

TODO : prevent export if errors
TODO : support CPU profiles

 */

init_obj.push(YASMed={
  header: ";;;;;;;;;;;;;;; end auto header ;;;;;;;;;;;;;;;",

  serial:0,  // must be set by a cookie !!!

  OddEvenArray:["even", "odd"],

  AdjustPClen:function(win){
    if (win.asmctx.name!="" && win.asmctx.core===false && config.core) {
      var t=win.LastAddress,
          i=0;
      while (t>0){
        i++;
        t>>>=1;
      }
      config.core.PC_length=i;
    }
  },

/*
Trash should be moved out, as a generic service

<div id="trash_div" style="display:none">
<img src="tool/trash.png" id="trash_image">
</div>

//    YASMed.trash_id=getById("trash_image");

  TrashOpen: function() {

  },

  TrashClose: function() {

  },

 trash_mouseover:function() {
  if ((listed.dragdropstate > 0) // drag&drop ?
   ||(ygwm.action_function==ygwm.mouse_drag)) { // interaction with ygwm
    listed.trash_image_id.style.left="0px";
    listed.trash_open=true;
  }
  return true;
},

// serves also as a callback for ygwm
trash_mouseout:function() {
  if (listed.trash_open) {
    listed.trash_image_id.style.right="0px";
    listed.trash_open=false;
    // detect that a window is being closed
    // cleanup of the moved window... getElement(,,) ?
    // cleanup the variables to avoid leaks
    return true;
  }
  return false;
},*/

  reassemble:function(ev, win) {
    if (!win)
      win=this;
    impASM.importCode(YASMed.export_ASM(-1,ygwm.getParent(win)));
  },

  export_ASM:function(ev, win) {
    if (!win)
      win=this;
    win=ygwm.getParent(win);
    if (win) {
      // ok now we have the window.
      var h="; "+win.FuncName+"\n; Generated on "+new Date().toGMTString()+"\n",
          t= win.list_header_id.nextSibling, i,j="";
      if (win.subst.length>0) {
        h+="; Dump of the substitution table :\n";
        for (i in win.subst)
          h+=".subst "+win.subst[i].src+" "+win.subst[i].dst+"\n";
      }
      h+="; Nothing written above this line will be saved.\n"+YASMed.header+"\n";
      while(t) {
        j+=t.source_id.source+"\n";
        if (t.source_id.source==YASMed.header)
          j="";
        t=t.nextSibling;
      }
      YASMed.AdjustPClen(win);
      if (ev===-1)
        return h+j;
      else
        savefile.save(win.FuncName+".yas",h+j);
    }
  },

  export_HEX:function(ev, win) {
    if (!win)
      win=this;
    win=ygwm.getParent(win);
    if (win) {
      // ok now we have the window.
      var h=";;yhx0\n;; Dump of "+win.FuncName+"\n;; Generated on "+new Date().toGMTString()+"\n",
          t= win.list_header_id.nextSibling, i;
      while(t) {
        if (t.error===1)
          return alert("Can't export if the code contains error(s)");
        if(t.bytes)
          for(i in t.bytes_array)
            h+=int2hex( t.bytes_array[i],1,1,1)+" ";
        if(t.source_id.source!="")
          h+="; "+t.source_id.source+"\n";
        t=t.nextSibling;
      }
      YASMed.AdjustPClen(win);
      savefile.save(win.FuncName+".yhx",h);
    }
  },

  export_VHDL:function(ev, win) {
    if (!win)
      win=this;
    win=ygwm.getParent(win);
    if (win) {
      if (win.LastAddress & 1)
        return alert("The number of bytes must be even");
      if ((typeof win.asmctx.core == "object")
        &&(typeof win.asmctx.core.PC_length == "number")
        &&(win.LastAddress > (1 << win.asmctx.core.PC_length) ))
        return alert("Too many instructions, memory too small");

      // ok now we have the window.
      var size=win.LastAddress>>1,
          t=win.list_header_id.nextSibling, i, j=0, k;
h="-- Dump of "+win.FuncName
+"\n-- Generated on "+new Date().toGMTString()+"\n"
+"Library work;\n"
+"    use work.yasep_definitions.all;\n"
+"    use work.yasep_utils.all;\n"
+"Library ieee;\n"
+"    use ieee.std_logic_1164.all;\n"
+"    use ieee.numeric_std.all;\n"
+"\n"
+"entity SynchRam16 is\n"
+" port(\n"
+"  clk, reset, en: in std_logic := '0';\n"
+"  NPC: in SLVAI;\n"
+"  RAM_out: out SLV16);\n"
+"end SynchRam16;\n"
+"\n"
+"architecture "+win.FuncName+" of SynchRam16 is\n"
+"  signal latched_addr : SLVAI := (SLVAI'range=>'0');\n"
+"  type RAM_array_type is array(0 to "+size+") of SLV16;\n"
+"  constant RAM_array : RAM_array_type := (\n";

      function emit_vhdl(s) {
        if (j++==0)
          k=s;
        else {
          j=0;
          h+=' "'+s+k+'",';
        }
      }

      function emit_SLV16(s,k) {
        var m='",';
        for (i=16; i>0; i--) {
          if (k & 1)
            m=(s & 1)+m;
          else
            m='-'+m;
          s>>>=1;
          k>>>=1;
        }
        h+=' "'+ m;
      }

      while(t) {
        if (t.error===1)
          return alert("Can't export if the code contains error(s)");
        if(t.bytes) {
          if (t.encoded_fields!=0) {
            emit_SLV16(t.encoded_instruction, t.encoded_fields);
            if (t.bytes > 2)
              emit_SLV16(t.encoded_instruction >>> 16, t.encoded_fields >>> 16);
          }
          else
            for(i in t.bytes_array)
              emit_vhdl(toBin( t.bytes_array[i],8)); // bug ???
        }
        if(t.source_id.source!="")
          h+=" -- "+t.source_id.source+"\n";
        t=t.nextSibling;
      }

      YASMed.AdjustPClen(win);

h+=" \"1111111111111111\" );\n"  // Add "INV" because I wouldn't bother removing the last comma, plus the auto-prefetch gets the next word !
+"\n"
+"begin\n"
+"  process(clk, en)\n"
+"  begin\n"
+"    if rising_edge(clk) and en='0' then\n"
+"      latched_addr <= NPC;\n"
+"    end if;\n"
+"  end process;\n"
+"\n"
+"  process(latched_addr ,reset)\n"
+"    variable adr: integer;\n"
+"  begin\n"
+"    if reset/='1' then\n"
+"      RAM_out <= (RAM_out'range=>'0');\n"
+"    else\n"
+"      adr := safe_to_integer(latched_addr);\n"
+"      if adr < 0 or adr >= RAM_array'length then\n"
+"        report \" Accessing instruction beyond limit at \" & integer'image(adr);\n"
+"        RAM_out <= (RAM_out'range=>'1');\n"
+"      else\n"
+"        RAM_out <= RAM_array(adr);\n"
+"      end if;\n"
+"    end if;\n"
+"  end process;\n"
+"end "+win.FuncName+";\n";
      savefile.save(win.FuncName+".vhdl",h);
    }
  },

  //////////////////////////////////////////////////////
  // cleanup a table, remove any #text node inbetween the TR TH and TDs
  // (proved to be necessary......)
  cleanup_table:function(tbody_id) {
    var t=tbody_id.firstChild, tr, td, td2;   /// !!!!
    // scan the tbody
    while (t) {
      // preload the next sibling because we might remove t
      tr=t.nextSibling;
      if (t.nodeName!="TR")
        tbody_id.removeChild(t);
      else {
        // recurse : scan the TD/TH
        td = t.firstChild;
        while (td != null) {
          td2=td.nextSibling;
          if ((td.nodeName!="TD")&&(td.nodeName!="TH"))
            t.removeChild(td);
          td=td2;
        }
      }
      t=tr;
    }
  },

  // usually called by AssembleLine
  renumber_lines:function(win,t,n,ad) {
    // param #2 : id of the first TR to modify
    // param #3 : its intended line number;
    // param #4 : byte address
    var p=t.parentNode;

    while (t != null) {
      t.className=YASMed.OddEvenArray[n & 1]; // update the background color
      t.numero_id.innerHTML=n;  // create/update the numbers
      t.TrLineNr = n++;

      t.address=ad;

      if (t.bytes>0){
        t.address_id.innerHTML=ad;
        ad+=t.bytes;
      }
      t=t.nextSibling; // go to the next element
    }

    // if the end of the list is reached,
    if (t == null) {
      p.nbElements=n; // update the element count.
      win.LastAddress_id.innerHTML=(win.LastAddress=ad);
    }
  },

  Reassemble_line: function(t){
    var u=t.parentNode;
    var win=ygwm.getParent(u);
    YASMed.AssembleLine(win,u,t.source,u.TrLineNr,u.address);
  },

  MakeRow: function(c) {
    var i,j,k, t=document.createElement("TR");
    for (i in c){
      j=document.createElement("TD");
      k=c[i];
      t[k+'_id']=j;
      j.className=k;
      switch(k) {
        case "plus" :   j.onclick=YASMed.duplicate_listing_row; break; // adapter plus tard
        case "source":
          edit_text.register(j,
            { size:60, maxsize:200, func:YASMed.Reassemble_line });
      }
      t.appendChild(j);
    }
    return t;
  },

//  NewSym: function(win,s) {
//    return YASMed.MakeRow(["numero","symval","symname","symtype", "symcomm","symdef","symused"]);
//  },

  AssembleLine: function(win, t, s, n, ad) {
    t.message_id.innerHTML=win.asm_error="";
    win.asmout="";
    t.source_id.source=s;
    t.source_id.innerHTML=s.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;");
    t.size_id.innerHTML="";
    t.bytes_array=[];
    t.bytes=0;
    t.error=0;

///// déterminer l'adresse

    if (s.length>0 && s[0]==='.') {
      // preprocessor directive ? get the next word
      s=s.replace(/[;].*/,"");  // remove any trailing comment
      s=s.replace(/\s+/g," ");  // combine multiple spaces
      s=s.replace(/[ ]$/g,"");  // strip trailing garbage
      var i, s2=s.split(" ");

      function parse_parameter2() {
        if (s2.length!=2) {
          t.message_id.innerHTML='<b>wrong directive format<b>';
          t.error=1;
          return false;
        }
        s2=s2[1];
        if (s2.length > 30) {
          t.message_id.innerHTML='<b>please keep names shorter than 30 characters</b>';
          t.error=1;
          return false;
        }
        // check for non alpha chars
        i=0;
        while (i < s2.length)
          if (alpha_chars[s2[i++]]!==1) {
            t.message_id.innerHTML='<b>/!\ contains a non-alpha character</b>';
            t.error=1;
            return false;
          }
        return s2;
      }

      switch(s2[0]) {
        case ".name": // Get the new name
          s=parse_parameter2();
          if (typeof s!= "string") return;
          // update the values
          win.name_id.innerHTML=
           win.FuncName=s;
          break;

        case ".profile": // Get the new name
          s=parse_parameter2();
          if (typeof s!= "string") return;
          if (s=="auto") {
            t.message_id.innerHTML='OK, generating the opcode map automatically';
            win.asmctx.core=false;
            break;
          }
          if (typeof profiles[s]!= "object")  {
            t.message_id.innerHTML='<b>This profile does not exist</b>';
            t.error=1;
            return;
          }
          win.asmctx.core=profiles[s];
          break;

        case ".subst$":
          s=parse_parameter2();
          if (typeof s!= "string") return;
          if (typeof (i=win.tsbus[s2[1]])=="number"){
            if (win.subst[i].dst!=ad){
              t.message_id.innerHTML='<b>same value, keeping the old definition</b>';
              break;
            }
          }
          s2=[false,s,""+ad];
          // fold !

        case ".subst":
          if (s2.length<2) {
            t.message_id.innerHTML='<b>Missing word to substitute<b>';
            t.error=1;
            break;
          }
          if (s2.length<3)
            t.message_id.innerHTML='/!\\ are you sure you really want to hide this word ?';

          var tr,dst="";
          i=2;
          while(i<s2.length) // ugly
            dst+=s2[i++]+" "; // concatenate the rest of the line

          (tr=document.createElement("DIV")).innerHTML="<b>"+s2[1].replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")
               +"</b> = \"<i>"+dst.replace(/[<]/g,"&lt;").replace(/[&]/g,"&amp;")+"\"</i>";
          var o={
            src:s2[1],
            dst:dst,
            rx:new RegExp(s2[1],"g"),
            tr:tr
          };
          win.subst_id.appendChild(tr);
          if (typeof (i=win.tsbus[s2[1]])=="number"){
            win.subst_id.removeChild(win.subst[i].tr);
            win.subst[i]=o;
          }
          else {
            win.tsbus[s2[1]]=win.subst.length;
            win.subst.push(o);
          }
          break;


        case ".label":
        case ".include":
        case ".org":
          s=parse_parameter2();
          if (typeof s!= "string") return;
          t.message_id.innerHTML='<b>Not implemented yet</b>';
          t.error=1;
          break;

        default: t.message_id.innerHTML='<b>unknown directive</b>';
                 t.error=1;
      }
    }
    else {
       for (var i in win.subst)
         s = s.replace(win.subst[i].rx, win.subst[i].dst);
      if (!Y.encode_instruction(s,win.asmctx))
        t.error=1;
      if (t.bytes=win.asmctx.encoded_size_bytes) {
        t.size_id.innerHTML=t.bytes;
        t.bytes_array=win.bytes_array;
        t.encoded_fields=win.asmctx.encoded_fields;
        t.encoded_instruction=win.asmctx.encoded_instruction;

        // add the instruction to the used list
        if (win.asmctx.name!="" && win.asmctx.core===false)
          config.changeInstruction("true",win.asmctx.name);
      }
      t.value_id.innerHTML=win.asmout;
      t.message_id.innerHTML=win.asm_error;
    }

    YASMed.renumber_lines(win,t,n,ad);
  },

  listed_id:["plus","numero","address","size","value","source","message"],

  NewLine: function(win,s) {
    var t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.appendChild(t);
    YASMed.AssembleLine(win,t,s,win.listed_id.nbElements,win.LastAddress);
  },

  FirstLine: function(ev) {
    var win=ygwm.getParent(this),
        t=YASMed.MakeRow(YASMed.listed_id);
    win.listed_id.insertBefore(t,win.list_header_id.nextSibling);
    YASMed.AssembleLine(win,t,"",0,win.start_address);
    return false;
  },

  duplicate_listing_row:function(ev) {
    // this is the id of the <td class="plus">
    var originalTR = this.parentNode,  // the TR
        p=originalTR.parentNode,       // The table
        win=ygwm.getParent(p);         // the window

    if (!ev.ctrlKey) { // Duplicate
      // new row:
      var newTR = YASMed.MakeRow(YASMed.listed_id);
      // include the new row in the table (which forces reflow and redraw)
      p.insertBefore(newTR,originalTR.nextSibling);
      YASMed.AssembleLine(win,newTR,ev.shiftKey?originalTR.source_id.source:"",
             originalTR.TrLineNr+1, originalTR.address+originalTR.bytes);
    }
    else {  // Erase
      if(originalTR.nextSibling)
        YASMed.renumber_lines(win,originalTR.nextSibling, originalTR.TrLineNr, originalTR.address);
      p.removeChild(originalTR);
    }
  },

  // Create a new editor
  start: function() {
    var plus, win, f="function"+YASMed.serial++,
      cont=document.createElement("DIV");
    cont.innerHTML=import_htmi("tool/YASMed");
    winman.patchInnerLinks(cont);
    win = ygwm.new_window("YASMed "+f, null, cont,
       600, 450, 120, 60, false, true, true, true, false, "doc_cygr");
    YASMed.cleanup_table(win.listed_id=getByClass("table_listing","TBODY",cont));
    win.list_header_id=getById("list_header","tr",cont);
    win.listed_id.nbElements=0;
    getById("export_asm" ,"input",win).onclick=YASMed.export_ASM;
    getById("export_hex" ,"input",win).onclick=YASMed.export_HEX;
    getById("export_vhdl","input",win).onclick=YASMed.export_VHDL;
    getById("reassemble" ,"input",win).onclick=YASMed.reassemble;
    (plus=getByClass("plus","th",win.list_header_id)).onclick=YASMed.FirstLine;

    // update the listing name :
    (win.name_id=getByClass("block_name","SPAN",win)).innerHTML=(win.FuncName=f);
    edit_text.register(win.name_id, { size:40,
       func: function(t){ win.FuncName=t.source },
       check: edit_text.filter_alpha });

    (win.start_address_id=getByClass("start_address","SPAN",win)).innerHTML=  win.start_address=
     (win.LastAddress_id =getByClass("last_address", "SPAN",win)).innerHTML=  win.LastAddress=   0;

    win.asmctx=new Y.ASM_context(
        function(col,msg){  // message display routine
          win.asm_error ='<span style="background-color:'+col+'">&nbsp;</span> '+msg;
        },
        function(data, size){ // emit_bin
          var i=[],h="";
          while (size--) { // displays every byte
            i.push(data&255);
            h=int2hex(data&255,1,1,1)+h;
            data>>=8;
          }
          win.bytes_array=i;
          win.asmout=h;
        },
        true
      );

    win.subst=[];
    win.tsbus=[];
    win.subst_id=getByClass("subst","DIV",win);

    return win;
  },

  init_obj: function(){
    YASMed.menuItem = menu.subMenuItem(menu.mainMenuItem("Tools"),"New&nbsp;ASM&nbsp;editor", "tool/YASMed");
  }
});
